      program mainsw 
C
C********************************************************************
C             re-written by Tarasova October 2005: 
C
C           New aerosol models with 100 levels CO2=360ppm
C
C-----The k-distributions of Fomin and Correa, (2005)
C-----are used 
C
C------------Aerosol properties of Continental, 
C              Maritime and Stratospheric aerosols
C                              are included
C      8 spectral intervals in 0.2-10 mcm:           
C UV+VIS: 
C  nband=3:  0.2-0.303, 0.303-0.323, 0.323-0.7  mcm
C NIR:
C  nband=5:  0.323-1.22, 0.70-1.22, 1.22-10.0, 1.22-2.27,  2.27-10.0
c
c
c-------  reading standard atm of 32 layers MLS.d 
c     
c*********************************************************************
c  Chou&Suarez   July, 1999 
c This is the source program for computing solar fluxes due to
c  absorption by water vapor, ozone, co2, o2, clouds, and aerosols
c  and due to scattering by clouds, aerosols, and gases.
c
c This is a vectorized code.  It computes fluxes simultaneously for
c  m soundings.
c
c The meaning, units and dimension of the input and output parameters
c  are given in the subroutine sorad.
c
c*********************************************************************
      implicit none

      integer m,np,i,k,ib
      integer NM           ! NEW
ctar      parameter(m=1,np=100)
      parameter(m=1,np=32)            
c-----input parameters
c
      real plevel(np+1),tlayer(np),wlayer(np),olayer(np)
      real pl(m,np+1),ta(m,np),wa(m,np),oa(m,np)
ctar      
      real zlayer(np),zdel(m,np), zla(np)     
      real cwc(m,np,3)
      real taucld(m,np,3),reff(m,np,3),fcld(m,np)
      real taual(m,np,8),ssaal(m,np,8),asyal(m,np,8)
      real cosz(m),rsuvbm(m),rsuvdf(m),rsirbm(m),rsirdf(m)
ctar    
      real s0  
      integer ict,icb
      logical overcast,cldwater
C
C---------NEW ARRAYS
C
ctar       REAL CO2(np+1),O2(np+1),co2a(m,np),o2a(m,np)       
ctar       REAL co2layer(np),o2layer(np)
       REAL co2       
       REAL CODW(np),CODI(np),CCF(np),CWCW(np)
       REAL CWCI(np),REFW(np),REFI(np)
ctar       
       REAL TAU_S(8),SSA_S(8),ASYM_S(8)
       REAL TAU_M(8),SSA_M(8),ASYM_M(8)       
       REAL TAU_C(8),SSA_C(8),ASYM_C(8)       
       REAL TAUA_V(np)
       REAL SAUVB,SAUVD,SAIRB,SAIRD,CSZA 
       REAL FDS_C,FDS_A,FUS_A,FNS_A
       REAL ABS_C,ABS_A, FUT_C
       REAL Z(np+1),P(np+1),T(np+1),WV(np+1),OZ(np+1) 
       REAL WVm(np+1),OZm(np+1),zl(np+1), TAUA_SUM                    
C                     
       CHARACTER C1*80, cMOD*13, aMOD*6, crel*1      

c-----output parameters

      real flx(m,np+1),flc(m,np+1),heatr(m,np)
      real fdiruv (m),fdifuv (m)
      real fdirpar(m),fdifpar(m)
      real fdirir (m),fdifir (m)
      REAL flx_d(m,np+1),flx_u(m,np+1)
      REAL flc_d(m,np+1),flc_u(m,np+1)      
c
**********************************************************************
c-----specify the extraterrestrial solar flux

c      data s0/1367./
c      data s0/1372.45/      
C
C-----SPECIFY AEROSOL PROPERTIES OF CONTINENTAL (C), MARITIME (M) AND
C-----STRATOSPHERIC (S) AEROSOLS 
C

C                CONTINENTAL (C) AEROSOLS,   8 intervals:
C
C     0.2-0.303 (0.252), 0.303-0.323 (0.313), 0.323-0.7 (0.512), 0.323-1.22, 
C     0.7-1.22,  1.22-10.0, 1.22-2.27, 2.27-10.0
     
        DATA TAU_C/2.09880,1.76676,1.08667,0.87224,0.56770,
     *   0.25307, 0.28098,0.12890/     
     
        DATA SSA_C/0.77936,0.89032,0.89711,0.86887,0.83504,
     *   0.75306,0.76509,0.69953/ 
	
        DATA ASYM_C/0.68684,0.65619,0.63822,0.63599,0.63209,
     *   0.68143,0.65978,0.77775/	    
C
C
C              MARITIME (M)  AEROSOLS,   8 intervals
C
       DATA TAU_M/1.23760,1.16595,1.01222,0.97019,0.90512,
     *   0.76353,0.80001,0.60126/  
C
       DATA SSA_M/0.92032,0.97951,0.99000,0.98782,0.98620,
     *   0.96099,0.98319,0.86221/      
C
       DATA ASYM_M/0.75748,0.74395,0.74600,0.74975,0.75541,
     *  0.77743,0.77184,0.80229/

C
C
C              STRATOSPHERIC (S)  AEROSOLS,  8 intervals
C
        DATA TAU_S/1.55000,1.53946,1.09667,0.81293,0.45271,
     *   0.10020,0.11383,0.03955/    
C
        DATA SSA_S/5*0.9999,0.90023,0.99161,0.49372/
c        
        DATA ASYM_S/0.69380,0.71722,0.73244,0.68702,0.63582,
     *   0.39456,0.44335,0.17748/
c     
C
C  INCLUDING FILE mainsw1.in OF INPUT DATA
C
       OPEN (unit=1, file='clrdtfd.in', status='old' )
       OPEN (unit=9, file='clrdtfd.out', status='unknown')       
C
        READ (1,*) C1,       
     * cMOD
        write (*,*) cMOD
     
        READ (1,*) C1,      
     * C1, 
     * overcast,          
     * C1,
     * C1,     
     * cldwater,     
     * C1,
     * C1,
     * ict,icb,
     * C1,     
     * CODW,
     * C1,     
     * CODI,
     * C1,     
     * CWCW,     
     * C1,     
     * CWCI,
     * C1,     
     * REFW,     
     * C1,     
     * REFI,                        
     * C1,
     * CCF,     
     * C1,
     * SAUVB, SAUVD, SAIRB, SAIRD,
     * C1,
     * CSZA,
     * C1,
     * aMOD,
     * C1,
     * crel,
     * C1,   
     * co2,
     * C1,
     * s0  
             
C  co2 = 300 ppv

        CLOSE (1)
C
C------READING OF STANDARD ATMOSPHERIC MODEL:
C        MLS.d, TRA.d, SWA.d
C       
C         
C       
C                                 
        OPEN (unit=2, file=cMOD, status='old')
C
ctar         READ (2,*) C1
ctar         READ (2,*) C1
ctar         READ (2,*) C1	 
C
ctar        DO I=1,np+1
ctar        READ (2,55) Z(I),P(I),T(I),WV(I),CO2(I),OZ(I),O2(I)
ctar        ENDDO
C
ctar          CLOSE (2)

C
         READ (2,*) C1,  
     *    NM
C
        READ (2,*) C1
C
        DO I=1,NM
        READ (2,55) Z(I),P(I),T(I),WV(I),OZ(I)
        ENDDO
C
          CLOSE (2)
C
C
C      pressure in mb from atm
C
ctar        DO I=1,np+1
ctar	P(I)=P(I)*1013.25
ctar        ENDDO	
C
ctar        DO I=1,np+1
ctar        plevel(I)=P(np+2-I)
ctar        zl(I)=Z(np+2-I)
ctar        ENDDO        
C        
ctar        DO I=1,np 
ctar	
ctar	zlayer(I)=zl(I)-zl(I+1)
ctar	zla(I)=(zl(I)+zl(I+1))/2.       
ctar        tlayer(I)=(T(np+2-I)+T(np+1-I))/2.
ctar	
ctar        wlayer(I)=(WV(np+2-I)+WV(np+1-I))/2.
ctar        olayer(I)=(OZ(np+2-I)+OZ(np+1-I))/2.
ctar	co2layer(I)=(CO2(np+2-I)+CO2(np+1-I))/2.
ctar	o2layer(I)=(O2(np+2-I)+O2(np+1-I))/2.
ctar        ENDDO 

C
        DO I=1,np+1
        plevel(I)=P(np+2-I)
        zl(I)=Z(np+2-I)
        WVm(I)=WV(I)*T(I)/(348.37*P(I))  ! g/g
        OZm(I)=OZ(I)*T(I)/(348.37*P(I))  ! g/g
        ENDDO        
C        
        DO I=1,np 
	zlayer(I)=zl(I)-zl(I+1)
	zla(I)=(zl(I)+zl(I+1))/2.    	       
        tlayer(I)=(T(np+2-I)+T(np+1-I))/2.
        wlayer(I)=(WVm(np+2-I)+WVm(np+1-I))/2.
        olayer(I)=(OZm(np+2-I)+OZm(np+1-I))/2.
        ENDDO        
C
C
c-----specify aerosol optical thickness (taual), single-scattering
c     albedo (ssaal), and asymmetry factor (asyal)

C
ctar------------ FORMATION OF AEROSOL VERTICAL PROFILE IN STRATOSPHERE
C
         DO I=1,np-12
C         
         IF (zla(I).GT.12.0.AND.zla(I).LE.20.0) THEN
         TAUA_V(I)=0.000218*(zl(I)-zl(I+1))
         ENDIF
C
         IF (zla(I).GT.20.0) TAUA_V(I)=0.
C
         ENDDO

C
          IF (aMOD.EQ.'A-ZERO') THEN
C
            do k= 1, np
            TAUA_V(k)= 0.
            enddo
C
          ENDIF

C
       do ib=1,8
        do k= 1, np-12
          do i= 1, m
               taual(i,k,ib) = TAU_S(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_S(ib)
               asyal(i,k,ib) = ASYM_S(ib)
          enddo
         enddo
       enddo
C
C
C---------IF CONT-I aerosol profile in troposphere
C         
C         
          IF (aMOD.EQ.'CONT-I') THEN
          DO I=np-11,np
C         
          IF (zla(I).GT.0.0.AND.zla(I).LE.2.0) THEN
          TAUA_V(I)=0.1*(zl(I)-zl(I+1))
          ENDIF
C
          IF (zla(I).GT.2.0.AND.zla(I).LE.12.0) THEN
          TAUA_V(I)=0.0025*(zl(I)-zl(I+1))
          ENDIF
C
          ENDDO
C
       do ib=1,8
        do k= np-11, np
          do i= 1, m
               taual(i,k,ib) = TAU_C(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_C(ib)
               asyal(i,k,ib) = ASYM_C(ib)
          enddo
         enddo
       enddo
C 
C          
          ENDIF

C---------IF CONT-A aerosol profile in troposphere
C         
C         
          IF (aMOD.EQ.'CONT-A') THEN
          DO I=np-11,np
C         
          IF (zla(I).GT.0.0.AND.zla(I).LE.2.0) THEN
          TAUA_V(I)=0.5*(zl(I)-zl(I+1))
          ENDIF
C
          IF (zla(I).GT.2.0.AND.zla(I).LE.12.0) THEN
          TAUA_V(I)=0.0025*(zl(I)-zl(I+1))
          ENDIF
C
          ENDDO
C
       do ib=1,8
        do k= np-11, np
          do i= 1, m
               taual(i,k,ib) = TAU_C(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_C(ib)
               asyal(i,k,ib) = ASYM_C(ib)
          enddo
         enddo
       enddo
C 
C          
          ENDIF

C
C---------IF MAR-I aerosol profile in troposphere
C
C         
          IF (aMOD.EQ.'MAR-I') THEN
          DO I=np-11,np
C         
          IF (zla(I).GT.0.0.AND.zla(I).LE.2.0) THEN
          TAUA_V(I)=0.025*(zl(I)-zl(I+1))
          ENDIF
C
          IF (zla(I).GT.2.0.AND.zla(I).LE.12.0) THEN
          TAUA_V(I)=0.0025*(zl(I)-zl(I+1))
          ENDIF
C
          ENDDO
C
       do ib=1,8
        do k= np-11, np-2
          do i= 1, m
               taual(i,k,ib) = TAU_C(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_C(ib)
               asyal(i,k,ib) = ASYM_C(ib)
          enddo
         enddo
       enddo
C
       do ib=1,8
        do k= np-1, np
          do i= 1, m
               taual(i,k,ib) = TAU_M(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_M(ib)
               asyal(i,k,ib) = ASYM_M(ib)
          enddo
         enddo
       enddo
C
C          
          ENDIF
C
C--------IF MAR-II aerosol profile in troposphere
C
C
C         
          IF (aMOD.EQ.'MAR-II') THEN
          DO I=np-11,np
C         
          IF (zla(I).GT.0.0.AND.zla(I).LE.2.0) THEN
          TAUA_V(I)=0.025*(zl(I)-zl(I+1))
          ENDIF
C
          IF (zla(I).GT.2.0.AND.zla(I).LE.6.0) THEN
          TAUA_V(I)=0.75*(zl(I)-zl(I+1))
          ENDIF
C
          IF (zla(I).GT.6.0.AND.zla(I).LE.12.0) THEN
          TAUA_V(I)=0.0025*(zl(I)-zl(I+1))
          ENDIF
C
          ENDDO
C
C
       do ib=1,8
        do k= np-11, np-2
          do i= 1, m
               taual(i,k,ib) = TAU_C(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_C(ib)
               asyal(i,k,ib) = ASYM_C(ib)
          enddo
         enddo
       enddo
C
       do ib=1,8
        do k= np-1, np
          do i= 1, m
               taual(i,k,ib) = TAU_M(ib)*TAUA_V(k)        
               ssaal(i,k,ib) = SSA_M(ib)
               asyal(i,k,ib) = ASYM_M(ib)
          enddo
         enddo
       enddo
C
C          
          ENDIF
C
         TAUA_SUM=0.
         DO I=1,np
         TAUA_SUM=TAUA_SUM+TAUA_V(I)
         ENDDO
C         
         WRITE (9,*) 'AEROSOL MODEL=', aMOD
c
C         
         WRITE (9,*) 'ATMOSPHERIC MODEL=', cMOD 
C
C               
C-------------------------------------------------------C     
c
C-------------------------------------------------------C
c-----pl,ta,wa and oa are, respectively, the level pressure (mb), layer
c     temperature (k), layer water vapor amount (g/g), and layer ozone 
c     concentration g/g
  
        do k=1,np
          do i=1,m
ctar	  
	    zdel(i,k)=zlayer(k)
            pl(i,k)=plevel(k)
            ta(i,k)=tlayer(k)
            wa(i,k)=wlayer(k)
            oa(i,k)=olayer(k)
ctar	    co2a(i,k)=co2layer(k)
ctar	    o2a(i,k)=o2layer(k)
         enddo
         enddo

c-----specify surface pressure

       do i=1,m
         pl(i,np+1)=plevel(np+1)
       enddo
C-----------------------------------------------------------C
c-----specify cloud optical thickness (taucld), amount (fcld), effective
c     particle size (reff).   cloud ice (index 1), liquid (index 2), and
c     rain (index 3) are allowed to co-exit in a layer.
c     cwc is the cloud ice/water concentration. If cldwater=.true.,
c     taucld is computed from cwc and reff.  If cldwater=.false.,
c     taucld is an input parameter, and cwc is irrelevent

       do k= 1, np
         do i= 1, m
            taucld(i,k,1)= CODI(k)  ! ICE PARTICLES
            taucld(i,k,2)= CODW(k)  ! WATER PARTICLES
            taucld(i,k,3)= 0.0  ! RAIN DROPS
            reff(i,k,1)  =REFI(k)  ! ICE PARTICLES
            reff(i,k,2)  =REFW(k)  ! WATER PARTICLES
            fcld(i,k)    = CCF(k)  ! CLOUD COVER 
            cwc(i,k,1)   = CWCI(k)
            cwc(i,k,2)   = CWCW(k)
            cwc(i,k,3)   = 0.0
         enddo
       enddo
c
c-----specify surface albedos in solar ir and uv+par regions
 
       do i=1,m      
         rsuvbm(i)=SAUVB              
         rsuvdf(i)=SAUVD                
         rsirbm(i)=SAIRB               
         rsirdf(i)=SAIRD         
       enddo

c-----specify cosine of the solar zenith angle

       do i=1,m
c        
         cosz(i)=CSZA         
c        
       enddo
c-----compute solar fluxes
C
c-----print out input data
      
ctar    
       write (9,101) s0,cosz(m),ict,icb,rsuvbm(m),rsuvdf(m)
     *              ,rsirbm(m),rsirdf(m)
       write (9,102)
       write (9,103)
       write (9,104)
c
       do i=m,m
        do k=1,np
           write (9,306) k,pl(i,k),zl(k), zdel(i,k)
           write (9,106) ta(i,k),wa(i,k),oa(i,k),reff(i,k,1),
     *                   reff(i,k,2),fcld(i,k),taual(i,k,4)
     *                   
     *                   
        enddo
       enddo
c
           write (9,105) np+1,pl(m,np+1)
c	   
c
ctar
ctar      call sorad (m,np,crel,pl,ta,wa,oa,co2a,o2a,zdel,
      call sorad (m,np,crel,pl,ta,wa,oa,co2,zdel,      
     *     overcast,cldwater,cwc,taucld,reff,fcld,ict,icb,
     *     taual,ssaal,asyal,
     *     cosz,rsuvbm,rsuvdf,rsirbm,rsirdf,
     *     flx,flc,fdiruv,fdifuv,fdirpar,fdifpar,fdirir,fdifir,
     *     flx_d,flx_u,flc_d,flc_u)    ! NEW   

c-----convert the units of flx and flc from fraction to w/m^2
C
cc      
C
      do k=1,np+1
        do i=1,m
          flx(i,k)=flx(i,k)*s0*cosz(i)
          flc(i,k)=flc(i,k)*s0*cosz(i)
          flx_d(i,k)=flx_d(i,k)*s0*cosz(i)   ! NEW          
          flx_u(i,k)=flx_u(i,k)*s0*cosz(i)   ! NEW 
          flc_d(i,k)=flc_d(i,k)*s0*cosz(i)   ! NEW           
          flc_u(i,k)=flc_u(i,k)*s0*cosz(i)   ! NEW                     
        enddo
      enddo

        do i=1,m
          fdiruv (i)=fdiruv (i)*s0*cosz(i)
          fdifuv (i)=fdifuv (i)*s0*cosz(i)
          fdirpar(i)=fdirpar(i)*s0*cosz(i)
          fdifpar(i)=fdifpar(i)*s0*cosz(i)
          fdirir (i)=fdirir (i)*s0*cosz(i)
          fdifir (i)=fdifir (i)*s0*cosz(i)
        enddo

c-----compute heating rates, c/day

      do k=1,np
        do i=1,m
          heatr(i,k)=8.4410*(flx(i,k)-flx(i,k+1))
     *                 /(pl(i,k+1)-pl(i,k))
        enddo
      enddo
      
c-----print out results
c
       write (9,202)
C
       write (9,208)
C       
       do i=m,m
        do k=1,np
           write (9,209) 100-k+1,pl(i,k),flx_d(i,k),flx_u(i,k),
     * heatr(i,k)
c     *        ,flc_d(i,k),flc_u(i,k)
        enddo
       enddo 
       write (9,209) 0,pl(m,np+1),flx_d(m,np+1),
     *flx_u(m,np+1),heatr(m,np)
c             
c
C--------- ALL_SKY DOWNWARD SURFACE FLUX 
C                 
C
          write (9,*)  ' ALL_SKY DOWNWARD SURFACE FLUX'
	  write (9,*) flx_d(m,np+1)
          write (9,*)  ' ALL_SKY UP TOP FLUX'
	  write (9,*) flx_u(m,1)	  
C                    
C
C--------ATMOSPHERIC ABSORPTION
C
          ABS_C=flc(m,1)-flc(m,np+1)
          ABS_A=flx(m,1)-flx(m,np+1)          
C
          write (9,*) 'ATMOSPHERIC ABSORPTION '
          write (9,*)  ABS_A	  
ctar         
C
          CLOSE (9)
c----- 
  100 format (/,'  ****  Sample mid-latitude summer atmosphere ****',/)
  101 format (/,'  s0    =', f7.1,'  w/m^2',/,'  cosz  =', f6.3,/,
     * '  ict   =',i3,/,'  icb   =',i3,/,
     * '  rsuvbm=',f5.2,/,'  rsuvdf=',f5.2,/,'  rsirbm=',f5.2,/,
     * '  rsirdf=',f5.2,/)
  102 format (/,' ******  INPUT DATA  ******',/)
  103 format (10x,'p',9x,'z',8x,'delz',5x,'T',8x,'q',
     * 8x,'o3',6x,'reff(1,2)',
     *        3x,'fcld',2x,'taual')
  104 format (9x,'(mb)',6x,'(km)',6x,'(km)',4x,'(K)',
     *5x,'(molec/cm2km)',5x, '(micron)',/)
  105 format (i4,f10.4,f10.4)
ctar
  305 format (i5,3E12.4)
  306 format (i4,3F10.2)    
  106 format (35x,f7.2,1p,2e10.3,1x,0p,1x,2f5.1,2x,f5.1,2x,f5.3)

  202 format (//,' ******  RESULTS  ******',/)
  203 format (10x,'p',8x,'flx',8x,'flc',5x,'all-sky heating')
  204 format (9x,'(mb)',4x,'(W/m^2)',4x,'(W/m^2)',7x,'(C/day)',/)
  205 format (i4,f10.4,f10.2,1x,f10.2)
  206 format (37x,f10.3)
  207 format (//,' fdiruv  = ',f7.2,/,' fdifuv  = ',f7.2,/,
     *           ' fdirpar = ',f7.2,/,' fdifpar = ',f7.2,/,
     *           ' fdirir  = ',f7.2,/,' fdifir  = ',f7.2)
  208 format (1x,'H,km',6x,'p(mb)',3x,'F all,d ',6x,
     * 'F all,u ',6x,'HR(K/d)')
ctar     * ,'F clr,d',2x,'F clr,u (W/m^2)',/)
  209 format (i5,f12.5,f12.6,1x,f12.6,1x,f10.2,1x,f10.2)
  210 format (2f10.4)   
ctar  55       FORMAT (F5.1,E12.4,F8.2,4E12.4)  
  55       FORMAT (1X,5E12.4) 
C  
      stop
      end
c      
c***********************       CLIRAD-SW      ************************
ctar 
      subroutine sorad (m,np,crel,pl,ta,wa,oa,co2,zdel,
     *                  overcast,cldwater,cwc,taucld,reff,fcld,ict,icb,
     *                  taual,ssaal,asyal,
     *                  cosz,rsuvbm,rsuvdf,rsirbm,rsirdf,
     *                  flx,flc,fdiruv,fdifuv,fdirpar,fdifpar,
     *                  fdirir,fdifir,
     *                  flx_d,flx_u,flc_d,flc_u) 
c
c**********************************************************************
c 
c     The subroutine is re-written by Tarasova for using of
c              Fomin and Correa, 2005  parameterizations, August 2005
c   
c    wa,oa,co2- water vapor g/g, ozone g/g, co2=300 ppv 
c
c    swa(m,np),soa(m,np),sco2(m,np),so2(m,np) - H2O,O3,CO2,O2 concentration
c                          in molec/cm^2 km divided here by  e+21,e+17,e+19,e+22
c    wh(m,np),oh(m,np),co2h(m,np),o2h(m,np) - gaseous amount at the solar 
c    beam in molec/cm^2 divided by e+21,e+17,e+19,e+22
c    zdel((m,np) - layer height in km
c
c
c
c Following the NASA Technical Memorandum (NASA/TM-1999-104606, Vol. 15)
c  of Chou and Suarez (1999), this routine computes solar fluxes due to 
c  absorption by water vapor, ozone, co2, o2, clouds, and aerosols and 
c  due to scattering by clouds, aerosols, and gases.
c
c This code computes fluxes simultaneously for m soundings.
c
c Cloud ice, liquid, and rain particles are allowed to co-exist in a layer. 
c
c There is an option of providing either cloud ice/water mixing ratio 
c  (cwc) or optical thickness (taucld).  If the former is provided, set
c  cldwater=.true., and taucld is computed from cwc and reff as a
c  function of spectra band. Otherwise, set cldwater=.false., and
c  specify taucld, independent of spectral band.
c
c If no information is available for the effective particle size, reff, 
c  default values of 10 micron for liquid water and 75 micron for ice may be 
c  used. 
c  The size of raindrops, reff(3), is irrelevant in this code. It can be
c  set to any values.
c  For a clear layer, reff can be set to any values except zero.
c
c The maximum-random assumption is applied for treating cloud
c  overlapping. Clouds are grouped into high, middle, and low clouds
c  separated by the level indices ict and icb.  For detail, see
c  subroutine "cldscale".
c
c In a high spatial-resolution atmospheric model, fractional cloud cover
c  might be computed to be either 0 or 1.  In such a case, scaling of the
c  cloud optical thickness is not necessary, and the computation can be
c  made faster by setting overcast=.true.  Otherwise, set the option
c  overcast=.false.
c
c Aerosol optical thickness, single-scattering albedo, and asymmetry
c  factor can be specified as functions of height and spectral band.
c
c----- Input parameters:                           
c                                                   units      size
c  number of soundings (m)                          n/d         1
c  number of atmospheric layers (np)                n/d         1
c  level pressure (pl)                              mb        m*(np+1)
c  layer temperature (ta)                           k         m*np
c  layer specific humidity (wa)                     gm/gm     m*np
c  layer ozone concentration (oa)                   gm/gm     m*np
c  co2 mixing ratio by volume (co2)                 pppv        1
c  option for scaling cloud optical thickness       n/d         1
c        overcast="true" if scaling is NOT required
c        overcast="fasle" if scaling is required
c  option for cloud optical thickness               n/d         1
c        cldwater="true" if cwc is provided
c        cldwater="false" if taucld is provided
c  cloud water mixing ratio (cwc)                  gm/gm      m*np*3
c        index 1 for ice particles
c        index 2 for liquid drops
c        index 3 for rain drops
c  cloud optical thickness (taucld)                 n/d       m*np*3
c        index 1 for ice particles
c        index 2 for liquid drops
c        index 3 for rain drops
c  effective cloud-particle size (reff)          micrometer   m*np*3
c        index 1 for ice particles
c        index 2 for liquid drops
c        index 3 for rain drops
c  cloud amount (fcld)                            fraction    m*np
c  level index separating high and middle           n/d         1
c        clouds (ict)
c  level index separating middle and low            n/d         1
c        clouds (icb)
c  aerosol optical thickness (taual)                n/d       m*np*11
c  aerosol single-scattering albedo (ssaal)         n/d       m*np*11
c  aerosol asymmetry factor (asyal)                 n/d       m*np*11
c        in the uv region :
c           index  1 for the 0.175-0.225 micron band
c           index  2 for the 0.225-0.245; 0.260-0.280 micron band
c           index  3 for the 0.245-0.260 micron band
c           index  4 for the 0.280-0.295 micron band
c           index  5 for the 0.295-0.310 micron band
c           index  6 for the 0.310-0.320 micron band
c           index  7 for the 0.325-0.400 micron band
c        in the par region :
c           index  8 for the 0.400-0.700 micron band
c        in the infrared region :
c           index  9 for the 0.700-1.220 micron band
c           index 10 for the 1.220-2.270 micron band
c           index 11 for the 2.270-10.00 micron band
c   cosine of solar zenith angle (cosz)              n/d      m
c   uv+visible sfc albedo for beam radiation
c        for wavelengths<0.7 micron (rsuvbm)       fraction   m
c   uv+visible sfc albedo for diffuse radiation
c        for wavelengths<0.7 micron (rsuvdf)       fraction   m
c   ir sfc albedo for beam radiation
c        for wavelengths>0.7 micron  (rsirbm)      fraction   m
c   ir sfc albedo for diffuse radiation (rsirdf)   fraction   m
c
c----- Output parameters
c
c   all-sky flux (downward minus upward) (flx)     fraction   m*(np+1)
c   clear-sky flux (downward minus upward) (flc)   fraction   m*(np+1)
c   all-sky direct downward uv (0.175-0.4 micron)
c                flux at the surface (fdiruv)      fraction   m
c   all-sky diffuse downward uv flux at
c                the surface (fdifuv)              fraction   m
c   all-sky direct downward par (0.4-0.7 micron)
c                flux at the surface (fdirpar)     fraction   m
c   all-sky diffuse downward par flux at
c                the surface (fdifpar)             fraction   m
c   all-sky direct downward ir (0.7-10 micron)
c                flux at the surface (fdirir)      fraction   m
c   all-sky diffuse downward ir flux at
c                the surface (fdifir)              fraction   m
c
c----- Notes:
c
c    (1) The unit of output fluxes (flx,flc,etc.) is fraction of the
c        insolation at the top of the atmosphere.  Therefore, fluxes
c        are the output fluxes multiplied by the extra-terrestrial solar
c        flux and the cosine of the solar zenith angle.
c    (2) pl( ,1) is the pressure at the top of the model, and
c        pl( ,np+1) is the surface pressure.
c    (3) the pressure levels ict and icb correspond approximately
c        to 400 and 700 mb.
c
c-----If coding errors are found, please notify Ming-Dah Chou at
c     chou@climate.gsfc.nasa.gov
c        
c*************************************************************************
 
      implicit none

c-----input parameters

      integer m,np,ict,icb
ctar      
      real pl(m,np+1),ta(m,np)
ctar      
      real so2(m,np),o2h(m,np),sco2(m,np),co2h(m,np)
      real swa(m,np), wh(m,np), soa(m,np), oh(m,np)
ctar      
      real wa(m,np),oa(m,np),co2            
ctar
      real zdel(m,np)      
      real cwc(m,np,3),taucld(m,np,3),reff(m,np,3),fcld(m,np)
      real taual(m,np,8),ssaal(m,np,8),asyal(m,np,8)
      real cosz(m),rsuvbm(m),rsuvdf(m),rsirbm(m),rsirdf(m)
      logical overcast,cldwater

c-----output parameters

      real flx(m,np+1),flc(m,np+1)
      REAL flx_d(m,np+1),flx_u(m,np+1)   ! NEW
      REAL flc_d(m,np+1),flc_u(m,np+1)   ! NEW      
C      
      real fdiruv (m),fdifuv (m)
      real fdirpar(m),fdifpar(m)
      real fdirir (m),fdifir (m)

c-----temporary array
 
      integer i,j,k,ntop,nctop(m)
      real cwp(m,np,3)
ctar      
      real dp(m,np)      
      real x
      real snt(m) 
      character crel*1     
c
      do i=1,m 
c-----snt is the secant of the solar zenith angle
         snt(i)=1.0/cosz(i)
      enddo
ctar
ctar
c----------wa, oa are in g/g, co2 is in ppv, o2 is 23.14%
c    Transformation of all gaseos concentrations into molec/cm^2 km
c             swa,    soa,    sco2,    so2   (molec/cm^2 km)
c  divided by e+21,   e+17,   e+19,    e+22
      
      do k=1,np
      do i=1,m
ctar
      swa(i,k)=wa(i,k)*3.346*348.37*0.5*
     * (pl(i,k)+pl(i,k+1))/ta(i,k)
ctar      
      soa(i,k)=oa(i,k)*1.255e+4*348.37*0.5*
     * (pl(i,k)+pl(i,k+1))/ta(i,k)
      so2(i,k)=0.007625e+3*(pl(i,k)+pl(i,k+1))/ta(i,k)      
      sco2(i,k)=0.0364*co2*(pl(i,k)+pl(i,k+1))/ta(i,k) 
ctar
      enddo 
      enddo       
      
c
c
 110   format (5E12.4)
 115   format (3x,'P,mb',6x,'H2Oe+21',6x,'O3e+17',6x,
     * 'O2e+22', 6x, 'CO2e+19')
c 
ctar
c----Calculation of wh, oh, co2h, o2h - gaseous amount in molec/cm^2
c------------------at the solar beam    
c 
c

      do i=1,m
      wh(i,1)=swa(i,1)*zdel(i,1)*snt(i)
      oh(i,1)=soa(i,1)*zdel(i,1)*snt(i)
      o2h(i,1)=so2(i,1)*zdel(i,1)*snt(i)       
      co2h(i,1)=sco2(i,1)*zdel(i,1)*snt(i)                  
      enddo       
c 
      do k=1,np-1
      do i=1,m
      wh(i,k+1)=wh(i,k)+swa(i,k+1)*zdel(i,k+1)*snt(i)
      oh(i,k+1)=oh(i,k)+soa(i,k+1)*zdel(i,k+1)*snt(i)
      o2h(i,k+1)= o2h(i,k)+so2(i,k+1)*zdel(i,k+1)*snt(i)      
      co2h(i,k+1)= co2h(i,k)+sco2(i,k+1)*zdel(i,k+1)*snt(i)                  
      enddo 
      enddo       
c
ctar          
c
c
c      
      do k=1,np
       do i=1,m
c
c-----compute layer thickness. indices for the surface level and
c     surface layer are np+1 and np, respectively.
 
          dp(i,k)=pl(i,k+1)-pl(i,k)
c 
c
c-----compute layer cloud water amount (gm/m**2)
c     the index is 1 for ice crystals, 2 for liquid drops, and
c     3 for rain drops

          x=1.02*10000.*dp(i,k)   
          cwp(i,k,1)=x*cwc(i,k,1)
          cwp(i,k,2)=x*cwc(i,k,2)
          cwp(i,k,3)=x*cwc(i,k,3)

       enddo
      enddo
c
c-----initialize fluxes for all-sky (flx), clear-sky (flc), and
c     flux reduction (df)
c
      do k=1,np+1
       do i=1,m
          flx(i,k)=0.
          flx_d(i,k)=0.    ! NEW
          flx_u(i,k)=0.    ! NEW
          flc(i,k)=0.                              
          flc_d(i,k)=0.    ! NEW
          flc_u(i,k)=0.    ! NEW                   
ctar         
       enddo
      enddo

c-----compute solar uv and par fluxes
C
ctar 
      call soluv (m,np,crel,swa,wh,soa,oh,pl,ta,
     *            so2,o2h,dp,zdel,overcast,cldwater,
     *            cwp,taucld,reff,ict,icb,fcld,cosz,
     *            taual,ssaal,asyal,rsuvbm,rsuvdf,
     *            flx,flc,fdiruv,fdifuv,fdirpar,fdifpar,
     *            flx_d,flx_u,flc_d,flc_u)  ! NEW   
C
c-----compute and update solar ir fluxes
C
cc    
C
      call solir (m,np,crel,swa,wh,soa,oh,so2,o2h,sco2,co2h,
     * dp,zdel,pl,ta,
     * overcast,cldwater,cwp,taucld,reff,ict,icb,fcld,cosz,
     *            taual,ssaal,asyal,rsirbm,rsirdf,
     *            flx,flc,fdirir,fdifir,
     *            flx_d,flx_u,flc_d,flc_u)  ! NEW      
C
      return
      end  
c
c******************************************************************
ctar
      subroutine soluv (m,np,crel,swa,wh,soa,oh,pl,ta,
     *            so2,o2h,dp,zdel,overcast,cldwater,
     *            cwp,taucld,reff,ict,icb,fcld,cosz,
     *            taual,ssaal,asyal,rsuvbm,rsuvdf,
     *            flx,flc,fdiruv,fdifuv,fdirpar,fdifpar,
     *            flx_d,flx_u,flc_d,flc_u)  ! NEW   

c******************************************************************
c     The subroutine is re-written by Tarasova for using of
c              Fomin and Correa, 2005  parameterizations, August 2005
c    wa(m,np),oa(m,np),co2,o2 - gaseous concentration in g/m^3, g/m^3, ppv, and %
c    swa(m,np),soa(m,np),so2(m,np) - H2O,O3,O2 concentration
c                          in molec/cm^2 km divided by  e+21,e+17,e+22
c    wh(m,np),oh(m,np),o2h(m,np) - gaseous amount at the solar beam in molec/cm^2
c    divided by e+21,e+17,e+22
c    zdel((m,np) - layer height in km
c 
c  nband=3:  0.2-0.303, 0.303-0.323, 0.323-0.7  mcm
c======================================================================
c  Chou and Suarez, 1999
c
c----- Input parameters:                            units      size
c
c  number of soundings (m)                          n/d         1
c  number of atmospheric layers (np)                n/d         1
c  layer scaled-water vapor content (wh)          gm/cm^2      m*np
c  layer ozone content (oh)                      (cm-atm)stp   m*np
c  layer pressure thickness (dp)                    mb         m*np
c  option for scaling cloud optical thickness       n/d         1
c        overcast="true" if scaling is NOT required
c        overcast="false" if scaling is required
c  input option for cloud optical thickness         n/d         1
c        cldwater="true" if taucld is provided
c        cldwater="false" if cwp is provided
c  cloud water amount (cwp)                        gm/m**2     m*np*3
c        index 1 for ice particles
c        index 2 for liquid drops
c        index 3 for rain drops
c  cloud optical thickness (taucld)                 n/d        m*np*3
c       index 1 for ice particles
c       index 2 for liquid drops
c       index 3 for rain drops
c  effective cloud-particle size (reff)          micrometer    m*np*3
c       index 1 for ice paticles
c       index 2 for liquid drops
c       index 3 for rain drops
c  level index separating high and                  n/d        m
c       middle clouds (ict)
c  level indiex separating middle and               n/d        m
c       low clouds (icb)
c  cloud amount (fcld)                            fraction     m*np
c  cosine of solar zenith angle (cosz)              n/d        m
c  aerosol optical thickness (taual)                n/d        m*np*11
c  aerosol single-scattering albedo (ssaal)         n/d        m*np*11
c  aerosol asymmetry factor (asyal)                 n/d        m*np*11
c  uv+par surface albedo for beam                 fraction     m
c       radiation (rsuvbm)
c  uv+par surface albedo for diffuse              fraction     m
c       radiation (rsuvdf)
c
c---- temporary array
c
c  scaled cloud optical thickness                   n/d        m*np
c       for beam radiation (tauclb)
c  scaled cloud optical thickness                   n/d        m*np
c       for diffuse radiation  (tauclf)     
c
c----- output (updated) parameters:
c
c  all-sky net downward flux (flx)               fraction      m*(np+1)
c  clear-sky net downward flux (flc)             fraction      m*(np+1)
c  all-sky direct downward uv flux at
c       the surface (fdiruv)                     fraction      m
c  all-sky diffuse downward uv flux at
c       the surface (fdifuv)                     fraction      m
c  all-sky direct downward par flux at
c       the surface (fdirpar)                    fraction      m
c  all-sky diffuse downward par flux at
c       the surface (fdifpar)                    fraction      m
c
c***********************************************************************

      implicit none

c-----input parameters

      integer m,np,ict,icb
      real taucld(m,np,3),reff(m,np,3),fcld(m,np)
      real cwp(m,np,3),wh(m,np),oh(m,np),dp(m,np)
ctar
      real swa(m,np),soa(m,np),so2(m,np),o2h(m,np),
     *  sco2(m,np),co2h(m,np),zdel(m,np) 
      real pl(m,np+1),ta(m,np),pa(m,np)         
      real taual(m,np,11),ssaal(m,np,11),asyal(m,np,11)
      real rsuvbm(m),rsuvdf(m),cosz(m)
      logical overcast,cldwater

c-----output (updated) parameter

      real flx(m,np+1),flc(m,np+1)
      real fdiruv (m),fdifuv (m)
      real fdirpar(m),fdifpar(m)
      REAL flx_d(m,np+1),flx_u(m,np+1)   !NEW
      REAL flc_d(m,np+1),flc_u(m,np+1)   !NEW     

c-----static parameters

      integer nband
c   
ctar      
      parameter (nband=3)
      real acuv(m,np,nband)
ctar      
      real hk(nband),ry(nband)      
      real aig(3),awg(3),arg(3)
      real aib(2),awb(2),arb(2)

c-----temporary array

      integer i,k,ib
      integer ih1,ih2,im1,im2,is1,is2
      real dsm(m)
      real tauclb(m,np),tauclf(m,np),asycl(m,np)
ctar     
      real taurs(m,np),taugas(m,np)
      real tausto(m,np),ssatau(m,np),asysto(m,np)
      real tautob(m,np),ssatob(m,np),asytob(m,np)
      real tautof(m,np),ssatof(m,np),asytof(m,np)
      real taux,reff1,reff2,g1,g2,g3
      real rr(m,np+1,2),tt(m,np+1,2),td(m,np+1,2),
     *     rs(m,np+1,2),ts(m,np+1,2)
      real fall(m,np+1),fclr(m,np+1),fsdir(m),fsdif(m)
      real asyclt(m),cc(m,3)
      real rrt(m,np),ttt(m,np),tdt(m,np),rst(m,np),tst(m,np)
      real dum1(m,np+1),dum2(m),dum(m,np)
      REAL fall_d(m,np+1),fall_u(m,np+1)   ! NEW
      REAL fclr_d(m,np+1),fclr_u(m,np+1)   ! NEW 
      character crel*1   
C      
c-----hk is the fractional extra-terrestrial solar flux in each
c     of the 3 bands.

      data hk/.01239,.009713,.44297/     
c
c-----ry is the extinction coefficient for Rayleigh scattering.
c     
c
      data ry /63.59,34.48,6.406/
c
c 
c-----coefficients for computing the extinction coefficients of ice, 
c     water, and rain particles, independent of spectral band. (Table 4)

      data aib/ 3.33e-4,2.52/
      data awb/-6.59e-3,1.65/
      data arb/ 3.07e-3,0.00/

c-----coefficients for computing the asymmetry factor of ice, water,
c     and rain particles, independent of spectral band. (Table 6)

      data aig/.74625,.0010541,-.00000264/
      data awg/.82562,.0052900,-.00014866/
      data arg/.883,0.0,0.0/

c-----initialize fdiruv, fdifuv, surface reflectances and transmittances.
c     the reflectance and transmittance of the clear and cloudy portions
c     of a layer are denoted by 1 and 2, respectively.
c     cc is the maximum cloud cover in each of the high, middle, and low
c     cloud groups.
c     1/dsm=1/cos(53) = 1.66
C
C
            
      do i=1,m                    
         dsm(i)=0.602
         fdiruv(i)=0.0
         fdifuv(i)=0.0
         rr(i,np+1,1)=rsuvbm(i)
         rr(i,np+1,2)=rsuvbm(i)
         rs(i,np+1,1)=rsuvdf(i)
         rs(i,np+1,2)=rsuvdf(i)
         td(i,np+1,1)=0.0
         td(i,np+1,2)=0.0
         tt(i,np+1,1)=0.0
         tt(i,np+1,2)=0.0
         ts(i,np+1,1)=0.0
         ts(i,np+1,2)=0.0
         cc(i,1)=0.0
         cc(i,2)=0.0
         cc(i,3)=0.0
      enddo

ctar
c
ctar-----Compute absorption coefficients of H2O,O3,O2
c
       call kuv (m,np,nband,soa,so2,swa,oh,o2h,
     * wh,acuv)
c
c
c
c      
 115   format (E12.4)      
c
c             
c-----Compute cloud optical thickness.  Eqs. (4.6) and (4.11)

      if (cldwater) then

       do k=1,np
        do i=1,m
          taucld(i,k,1)=cwp(i,k,1)*(aib(1)+aib(2)/reff(i,k,1))
          taucld(i,k,2)=cwp(i,k,2)*(awb(1)+awb(2)/reff(i,k,2))
          taucld(i,k,3)=cwp(i,k,3)* arb(1)
        enddo
       enddo

      endif

c-----options for scaling cloud optical thickness

      if (overcast) then

       do k=1,np
        do i=1,m
          tauclb(i,k)=taucld(i,k,1)+taucld(i,k,2)+taucld(i,k,3)
          tauclf(i,k)=tauclb(i,k)
        enddo
       enddo

       do k=1,3
        do i=1,m
           cc(i,k)=1.0
        enddo
       enddo

      else

c-----scale cloud optical thickness in each layer from taucld (with
c     cloud amount fcld) to tauclb and tauclf (with cloud amount cc).
c     tauclb is the scaled optical thickness for beam radiation and
c     tauclf is for diffuse radiation (see section 7).
C
C
         call cldscale(m,np,cosz,fcld,taucld,ict,icb,
     *                 cc,tauclb,tauclf)

      endif
C       
C
c-----cloud asymmetry factor for a mixture of liquid and ice particles.
c     unit of reff is micrometers. Eqs. (4.8) and (6.4)

      do k=1,np
       do i=1,m

           asyclt(i)=1.0
           taux=taucld(i,k,1)+taucld(i,k,2)+taucld(i,k,3)

         if (taux.gt.0.02 .and. fcld(i,k).gt.0.01) then

           reff1=min(reff(i,k,1),130.)
           reff2=min(reff(i,k,2),20.0)

           g1=(aig(1)+(aig(2)+aig(3)*reff1)*reff1)*taucld(i,k,1)
           g2=(awg(1)+(awg(2)+awg(3)*reff2)*reff2)*taucld(i,k,2)
           g3= arg(1)*taucld(i,k,3)
           asyclt(i)=(g1+g2+g3)/taux

         endif
       enddo
         do i=1,m
           asycl(i,k)=asyclt(i)
         enddo
      enddo
c      
c-----pressure at middle levels in atm.    2026.5 = 1013.25*2.0   
c 
      do k=1,np
       do i=1,m   
      pa(i,k)=(pl(i,k)+pl(i,k+1))/2026.5
      enddo            
      enddo
c      
c-----integration over spectral bands

      do 100 ib=1,nband

       do k=1,np
        do i=1,m
ctar
c-----compute new rayleigh optical thicknesses

          taurs(i,k)=ry(ib)*pa(i,k)/ta(i,k)*zdel(i,k)

             if (crel.eq.'n')  taurs(i,k)=0.0
	
c-----compute gaseous optical thickness in each interval

          taugas(i,k)=acuv(i,k,ib)*zdel(i,k)

c-----compute clear-sky optical thickness, single scattering albedo,
c     and asymmetry factor (Eqs. 6.2-6.4)

ctar          tausto(i,k)=taurs+tauoz+tauwv+taual(i,k,ib)+1.0e-8
          tausto(i,k)=taurs(i,k)+taugas(i,k)+taual(i,k,ib)	  
          ssatau(i,k)=ssaal(i,k,ib)*taual(i,k,ib)+taurs(i,k)
          asysto(i,k)=asyal(i,k,ib)*ssaal(i,k,ib)*taual(i,k,ib)

c-----compute reflectance and transmittance of the clear portion of a layer

          tautob(i,k)=tausto(i,k)
          ssatob(i,k)=ssatau(i,k)/tautob(i,k)+1.0e-8
          ssatob(i,k)=min(ssatob(i,k),0.999999)
          asytob(i,k)=asysto(i,k)/(ssatob(i,k)*tautob(i,k))

        enddo
       enddo
       
c
C                             
 200    format (2E12.4)            
C
         call deledd (m,np,tautob,ssatob,asytob,cosz,rrt,ttt,tdt)

c-----diffuse incident radiation is approximated by beam radiation with
c     an incident angle of 53 degrees, Eqs. (6.5) and (6.6)
C
C           
         call deledd (m,np,tautob,ssatob,asytob,dsm,rst,tst,dum)

       do k=1,np
        do i=1,m
           rr(i,k,1)=rrt(i,k)
           tt(i,k,1)=ttt(i,k)
           td(i,k,1)=tdt(i,k)
           rs(i,k,1)=rst(i,k)
           ts(i,k,1)=tst(i,k)
        enddo
       enddo

c-----compute reflectance and transmittance of the cloudy portion of a layer

       do k=1,np
        do i=1,m

c-----for direct incident radiation
c     The effective layer optical properties. Eqs. (6.2)-(6.4)

           tautob(i,k)=tausto(i,k)+tauclb(i,k)
           ssatob(i,k)=(ssatau(i,k)+tauclb(i,k))/tautob(i,k)+1.0e-8
           ssatob(i,k)=min(ssatob(i,k),0.999999)
           asytob(i,k)=(asysto(i,k)+asycl(i,k)*tauclb(i,k))
     *                /(ssatob(i,k)*tautob(i,k))

c-----for diffuse incident radiation

           tautof(i,k)=tausto(i,k)+tauclf(i,k)
           ssatof(i,k)=(ssatau(i,k)+tauclf(i,k))/tautof(i,k)+1.0e-8
           ssatof(i,k)=min(ssatof(i,k),0.999999)
           asytof(i,k)=(asysto(i,k)+asycl(i,k)*tauclf(i,k))
     *                /(ssatof(i,k)*tautof(i,k))

        enddo
       enddo

c-----for direct incident radiation
c     note that the cloud optical thickness is scaled differently for direct
c     and diffuse insolation, Eqs. (7.3) and (7.4).

         call deledd (m,np,tautob,ssatob,asytob,cosz,rrt,ttt,tdt)

c-----diffuse incident radiation is approximated by beam radiation with
c     an incident angle of 53 degrees, Eqs. (6.5) and (6.6)

         call deledd (m,np,tautof,ssatof,asytof,dsm,rst,tst,dum)

       do k=1,np
        do i=1,m

           rr(i,k,2)=rrt(i,k)
           tt(i,k,2)=ttt(i,k)
           td(i,k,2)=tdt(i,k)
           rs(i,k,2)=rst(i,k)
           ts(i,k,2)=tst(i,k)

        enddo
       enddo

c-----flux calculations

c     initialize clear-sky flux (fclr), all-sky flux (fall), 
c     and surface downward fluxes (fsdir and fsdif)

        do k=1,np+1
         do i=1,m
           fclr(i,k)=0.0
           fall(i,k)=0.0
           fclr_d(i,k)=0.0  ! NEW           
           fclr_u(i,k)=0.0  ! NEW           
           fall_d(i,k)=0.0  ! NEW
           fall_u(i,k)=0.0  ! NEW           
           dum1(i,k)=0.0           
         enddo
        enddo

        do i=1,m
           fsdir(i)=0.0
           fsdif(i)=0.0
	   dum2(i)=0.0
        enddo

        if (overcast) then

              ih1=1
              ih2=1
              im1=1
              im2=1
              is1=1
              is2=1

c-----for clear-sky fluxes only
C
C
         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,fclr,dum1,dum2,dum2,
     *                fclr_d,fclr_u,dum1,dum1)   ! NEW
C
C             

           do k=1,np+1
            do i=1,m
              fall(i,k)=0.0         
           fall_d(i,k)=0.0  ! NEW
           fall_u(i,k)=0.0  ! NEW 
	   dum1(i,k)=0.0                  
C              
            enddo
           enddo

           do i=1,m
              fsdir(i)=0.0
              fsdif(i)=0.0
           enddo

              ih1=2
              ih2=2
              im1=2
              im2=2
              is1=2
              is2=2

c-----for cloudy-sky fluxes only

         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,dum1,fall,fsdir,fsdif,
     *                 dum1,dum1,fall_d,fall_u)  ! NEW
C
        else

              ih1=1
              ih2=2
              im1=1
              im2=2
              is1=1
              is2=2

c-----for clear- and all-sky fluxes
c     the all-sky flux, fall is the summation inside the brackets
c     of Eq. (7.11)

         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,fclr,fall,fsdir,fsdif,
     *               fclr_d,fclr_u,fall_d,fall_u)   ! NEW

        endif

c-----flux integration, Eq. (6.1)

       do k=1,np+1
        do i=1,m
          flx(i,k)=flx(i,k)+fall(i,k)*hk(ib)
          flx_d(i,k)=flx_d(i,k)+fall_d(i,k)*hk(ib) !NEW         
          flx_u(i,k)=flx_u(i,k)+fall_u(i,k)*hk(ib) !NEW           
        enddo

        do i=1,m
          flc(i,k)=flc(i,k)+fclr(i,k)*hk(ib)
          flc_d(i,k)=flc_d(i,k)+fclr_d(i,k)*hk(ib) !NEW           
          flc_u(i,k)=flc_u(i,k)+fclr_u(i,k)*hk(ib) !NEW           
C          
        enddo
       enddo

c-----compute direct and diffuse downward surface fluxes in the UV
c     and par regions

       if(ib.le.2) then

        do i=1,m
          fdiruv(i)=fdiruv(i)+fsdir(i)*hk(ib)
          fdifuv(i)=fdifuv(i)+fsdif(i)*hk(ib)
        enddo

       else

        do i=1,m
          fdirpar(i)=fsdir(i)*hk(ib)
          fdifpar(i)=fsdif(i)*hk(ib)
        enddo

       endif
       
 100  continue
 
c
c 
      return
      end
c
c
c***********************************************************************

      subroutine solir (m,np,crel,swa,wh,soa,oh,so2,o2h,sco2,co2h,
     * dp,zdel,pl,ta,
     * overcast,cldwater,cwp,taucld,reff,ict,icb,fcld,cosz,
     *            taual,ssaal,asyal,rsirbm,rsirdf,
     *            flx,flc,fdirir,fdifir,
     *            flx_d,flx_u,flc_d,flc_u)  ! NEW      
 
c************************************************************************
c 
c     The subroutine is re-written by Tarasova for using of
c              Fomin and Correa, 2005  parameterizations, August 2005
c    swa(m,np),soa(m,np),sco2(m,np),so2(m,np)-H2O,O3,CO2,O2 concentration
c                          in molec/cm^2 km divided by  e+21,e+17,e+19,e+22
c    wh(m,np),oh(m,np),co2h(m,np),o2h(m,np) - gaseous amount at the solar beam 
c    in molec/cm^2 divided by e+21,e+17,e+19,e+22
c    zdel((m,np) - layer height in km
c
c
c  compute solar flux in the infrared region. The spectrum is divided
c   into 5 bands:
c
c          band   wavenumber(/cm)  wavelength (micron)
c          1                       0.323-1.22
c          2     14280-8200        0.70-1.22
c          3     8200-1000         1.22-10.0
c          4     8200-4400         1.22-2.27
c          5     4400-1000         2.27-10.0
c        
c
c----- Input parameters:                            units      size
c
c  number of soundings (m)                          n/d         1
c  number of atmospheric layers (np)                n/d         1
c  layer scaled-water vapor content (wh)          gm/cm^2      m*np
c  option for scaling cloud optical thickness       n/d         1
c        overcast="true" if scaling is NOT required
c        overcast="false" if scaling is required
c  input option for cloud optical thickness         n/d         1
c        cldwater="true" if taucld is provided
c        cldwater="false" if cwp is provided
c  cloud water concentration (cwp)                gm/m**2      m*np*3
c        index 1 for ice particles
c        index 2 for liquid drops
c        index 3 for rain drops
c  cloud optical thickness (taucld)                 n/d        m*np*3
c        index 1 for ice paticles
c        index 2 for liquid drops
c        index 3 for rain drops
c  effective cloud-particle size (reff)           micrometer   m*np*3
c        index 1 for ice paticles
c        index 2 for liquid drops
c        index 3 for rain drops
c  level index separating high and                  n/d        m
c        middle clouds (ict)
c  level index separating middle and                n/d        m
c        low clouds (icb)
c  cloud amount (fcld)                            fraction     m*np
c  aerosol optical thickness (taual)                n/d        m*np*11
c  aerosol single-scattering albedo (ssaal)         n/d        m*np*11
c  aerosol asymmetry factor (asyal)                 n/d        m*np*11 
c  near ir surface albedo for beam                fraction     m
c        radiation (rsirbm)
c  near ir surface albedo for diffuse             fraction     m
c        radiation (rsirdf)
c
c---- temporary array
c
c  scaled cloud optical thickness                   n/d        m*np
c          for beam radiation (tauclb)
c  scaled cloud optical thickness                   n/d        m*np
c          for diffuse radiation  (tauclf)     
c
c----- output (updated) parameters:
c
c  all-sky flux (downward-upward) (flx)           fraction     m*(np+1)
c  clear-sky flux (downward-upward) (flc)         fraction     m*(np+1)
c  all-sky direct downward ir flux at
c          the surface (fdirir)                   fraction     m
c  all-sky diffuse downward ir flux at
c          the surface (fdifir)                   fraction     m
c
c**********************************************************************
      implicit none

c-----input parameters

      integer m,np,ict,icb
      integer ih1,ih2,im1,im2,is1,is2
      real cwp(m,np,3),taucld(m,np,3),reff(m,np,3)
      real fcld(m,np),cosz(m)
      real rsirbm(m),rsirdf(m)
      real taual(m,np,8),ssaal(m,np,8),asyal(m,np,8)
      real dp(m,np),wh(m,np)
      logical overcast,cldwater
ctar      
      real pl(m,np+1),ta(m,np),zdel(m,np),tsrf(m),pa(m,np)
      real so2(m,np),o2h(m,np),sco2(m,np),co2h(m,np)
      real swa(m,np), soa(m,np), oh(m,np)
      real acir(m,np,20)                        
ctar
c-----output (updated) parameters

      real flx(m,np+1),flc(m,np+1)
      real fdirir(m),fdifir(m)
      REAL flx_d(m,np+1),flx_u(m,np+1)   !NEW
      REAL flc_d(m,np+1),flc_u(m,np+1)   !NEW        
      
c-----static parameters

ctar     
      integer nband      
ctar  
      parameter (nband=5)
      integer nk(5),ichan      
ctar    
      real hk(nband,4),ry(nband)      
      real aib(nband,2),awb(nband,2),arb(nband,2)
      real aia(nband,3),awa(nband,3),ara(nband,3)
      real aig(nband,3),awg(nband,3),arg(nband,3) 
c-----temporary array
      integer ib,iv,ik,i,k
      real dsm(m)
      real tauclb(m,np),tauclf(m,np),cc(m,3)
      real ssacl(m,np),asycl(m,np)
      real rr(m,np+1,2),tt(m,np+1,2),td(m,np+1,2),
     *     rs(m,np+1,2),ts(m,np+1,2)
      real fall(m,np+1),fclr(m,np+1),fsdir(m),fsdif(m)

ctar    
      real taurs(m,np),taugas(m,np)      
      real tausto(m,np),ssatau(m,np),asysto(m,np)
      real tautob(m,np),ssatob(m,np),asytob(m,np)
      real tautof(m,np),ssatof(m,np),asytof(m,np)
      real taux,reff1,reff2,w1,w2,w3,g1,g2,g3
      real ssaclt(m),asyclt(m)
      real rrt(m,np),ttt(m,np),tdt(m,np),rst(m,np),tst(m,np)
      real dum1(m,np+1),dum2(m),dum(m,np)
      REAL fall_d(m,np+1),fall_u(m,np+1)   ! NEW
      REAL fclr_d(m,np+1),fclr_u(m,np+1)   ! NEW  
      character crel*1  
      
c
c   number of k-distribution terms in each interval
c
      data nk/1,3,1,4,3/
      data hk/0.006887,0.20318,0.01032,0.09006,0.01381,
     *  0.,0.06211,0.,0.0187,0.009589,
     *  0.,0.05358,0.,0.01906,0.01336,
     *  0.,0.,0.,0.03427,0./
c
c
c-----ry is the extinction coefficient for Rayleigh scattering.
c 
      data ry /0.5382,0.5382,0.0,0.0598,0.0/      

c-----coefficients for computing the extinction coefficients of
c     ice, water, and rain particles 
ctar     
      data aib/
     1  .000333, .000333, .000333, .000333,.000333,
     2     2.52,   2.52,   2.52, 2.52, 2.52/     
ctar     
      data awb/
     1  -0.00806,-0.0101, -0.0198, -0.0166, -0.0339,
     2     1.68, 1.72,    1.91,    1.85,   2.16/     
ctar
      data arb/
     1   0.00307, 0.00307,0.00307, 0.00307, 0.00307,
     2   0.0    , 0.0    , 0.0    , 0.0  , 0.0  /     
     
c-----coefficients for computing the single-scattering co-albedo of
c     ice, water, and rain particles (Table 5)
ctar     
      data aia/
     1 -.00000260,-.00000260, .00215346, .00215346, .08938331,
     2  .00000746,  .00000746, .00073709, .00073709,  .00299387,
     3  .00000000, .00000000,-.00000134, -.00000134, -.00001038/     
ctar     
      data awa/
     1 .00000003, .00000007,.01209318, -.00019934, .01209318,
     2  .00000354,.00000845,.01784739, .00088757, .01784739,
     3 -.000000017, -.00000004,-.00036910, -.00000650, -.00036910/     
ctar
      data ara/
     1 .029, .029,      .342,  .342,  .466,
     2 .0000,  .0000,     .000,  .000,  .000,
     3 .0000, .0000,     .000,  .000,  .000/     

c-----coefficients for computing the asymmetry factor of 
c     ice, water, and rain particles (Table 6)
ctar  aig and arg are not recalculated (Tarasova)
      data aig/
     1 .74935228, .74935228, .84090400, .76098937, .84090400,
     2  .00119715, .00119715, .00126222 , .00141864, .00126222,
     3 -.00000367,-.00000367, -.00000385 , -.00000396, -.00000385/     
ctar     
      data awg/
     1  .79375035, .79375035, .83530748 ,.74513197, .83530748,
     2  .00832441, .00832441,.00257181 ,.01370071, .00257181,
     3  -.00023263, -.00023263,.00005519, -.00038203,.00005519/     
ctar     
      data arg/
     1 .891,  .891,      .948,  .948,    .971,
     2 .0000, .0000,     .000,  .000,     .000,
     3  .0000, .0000,     .000,   .000,    .000/     

c-----initialize surface fluxes, reflectances, and transmittances.
c     the reflectance and transmittance of the clear and cloudy portions
c     of a layer are denoted by 1 and 2, respectively.
c     cc is the maximum cloud cover in each of the high, middle, and low
c     cloud groups.
c     1/dsm=1/cos(53)=1.66

      do i=1,m
         dsm(i)=0.602
         fdirir(i)=0.0
         fdifir(i)=0.0
         rr(i,np+1,1)=rsirbm(i)
         rr(i,np+1,2)=rsirbm(i)
         rs(i,np+1,1)=rsirdf(i)
         rs(i,np+1,2)=rsirdf(i)
         td(i,np+1,1)=0.0
         td(i,np+1,2)=0.0
         tt(i,np+1,1)=0.0
         tt(i,np+1,2)=0.0
         ts(i,np+1,1)=0.0
         ts(i,np+1,2)=0.0
         cc(i,1)=0.0
         cc(i,2)=0.0
         cc(i,3)=0.0
      enddo

c-----Compute absorption coefficients of H2O,O3,O2,CO2 in 11 channels
c
         do i=1,m
          tsrf(i)=ta(i,np)
         enddo	  
c  
c-----pressure at middle levels (atm.)    2026.5 = 1013.25*2.0   
c 
      do k=1,np
       do i=1,m   
      pa(i,k)=(pl(i,k)+pl(i,k+1))/2026.5
      enddo            
      enddo      
c     
       call kir (m,np,so2,soa,sco2,swa,
     * o2h,oh,co2h,wh,ta,tsrf,pa,acir)       
c       
c
c
c     
 115   format (E12.4)      
c       
c-----integration over spectral bands

      do 100 ib=1,nband

ctar      
       iv=ib+3       

c-----Compute cloud optical thickness. Eqs. (4.6) and (4.11)

      if (cldwater) then

       do k=1,np
        do i=1,m
          taucld(i,k,1)=cwp(i,k,1)*(aib(ib,1)
     *                    +aib(ib,2)/reff(i,k,1))
          taucld(i,k,2)=cwp(i,k,2)*(awb(ib,1)
     *                    +awb(ib,2)/reff(i,k,2))
          taucld(i,k,3)=cwp(i,k,3)*arb(ib,1)
        enddo
       enddo

      endif

c-----options for scaling cloud optical thickness

      if (overcast) then

       do k=1,np
        do i=1,m
          tauclb(i,k)=taucld(i,k,1)+taucld(i,k,2)+taucld(i,k,3)
          tauclf(i,k)=tauclb(i,k)
        enddo
       enddo

       do k=1,3
        do i=1,m
          cc(i,k)=1.0
        enddo
       enddo

      else

c-----scale cloud optical thickness in each layer from taucld (with
c     cloud amount fcld) to tauclb and tauclf (with cloud amount cc).
c     tauclb is the scaled optical thickness for beam radiation and
c     tauclf is for diffuse radiation.

       call cldscale(m,np,cosz,fcld,taucld,ict,icb,
     *              cc,tauclb,tauclf)

      endif

c-----compute cloud single scattering albedo and asymmetry factor
c     for a mixture of ice and liquid particles.
c     Eqs.(4.6)-(4.8), (6.2)-(6.4)

       do k=1,np

        do i=1,m

           ssaclt(i)=0.99999
           asyclt(i)=1.0

           taux=taucld(i,k,1)+taucld(i,k,2)+taucld(i,k,3)
          if (taux.gt.0.02 .and. fcld(i,k).gt.0.01) then

           reff1=min(reff(i,k,1),130.)
           reff2=min(reff(i,k,2),20.0)

           w1=(1.-(aia(ib,1)+(aia(ib,2)+
     *         aia(ib,3)*reff1)*reff1))*taucld(i,k,1)
           w2=(1.-(awa(ib,1)+(awa(ib,2)+
     *         awa(ib,3)*reff2)*reff2))*taucld(i,k,2)
           w3=(1.- ara(ib,1))*taucld(i,k,3)
           ssaclt(i)=(w1+w2+w3)/taux

           g1=(aig(ib,1)+(aig(ib,2)+aig(ib,3)*reff1)*reff1)*w1
           g2=(awg(ib,1)+(awg(ib,2)+awg(ib,3)*reff2)*reff2)*w2
           g3= arg(ib,1)*w3
           asyclt(i)=(g1+g2+g3)/(w1+w2+w3)

          endif

        enddo

         do i=1,m
           ssacl(i,k)=ssaclt(i)
         enddo
         do i=1,m
           asycl(i,k)=asyclt(i)
         enddo

       enddo
c
        
c-----integration over the nk k-distribution functions in each ib interval

       do 200 ik=1,nk(ib)

        do k=1,np
         do i=1,m
ctar
c-----compute new rayleigh optical thicknesses

         taurs(i,k)=ry(ib)*pa(i,k)/ta(i,k)*zdel(i,k)
	 
            if (crel.eq.'n')  taurs(i,k)=0.0	 

c-----compute gaseous optical thickness in each interval

          ichan=4*(ib-1)+ik
c	 
          taugas(i,k)=acir(i,k,ichan)*zdel(i,k)          
c
c-----compute clear-sky optical thickness, single scattering albedo,
c     and asymmetry factor. Eqs.(6.2)-(6.4)
 
ctar      tausto(i,k)=taurs(i,k)+taugas(i,k)+taual(i,k,iv)+1.0e-8
      tausto(i,k)=taurs(i,k)+taugas(i,k)+taual(i,k,iv)      
      ssatau(i,k)=ssaal(i,k,iv)*taual(i,k,iv)+taurs(i,k)
      asysto(i,k)=asyal(i,k,iv)*ssaal(i,k,iv)*taual(i,k,iv)
      
c       
c-----compute reflectance and transmittance of the clear portion of a layer

           tautob(i,k)=tausto(i,k)
           ssatob(i,k)=ssatau(i,k)/tautob(i,k)+1.0e-8
           ssatob(i,k)=min(ssatob(i,k),0.999999)
           asytob(i,k)=asysto(i,k)/(ssatob(i,k)*tautob(i,k))

         enddo
        enddo	
cc 
c
cc                              
 205    format (2E12.4) 
       
c             	

c-----for direct incident radiation

         call deledd (m,np,tautob,ssatob,asytob,cosz,rrt,ttt,tdt)

c-----diffuse incident radiation is approximated by beam radiation with
c     an incident angle of 53 degrees, Eqs. (6.5) and (6.6)

c    
         call deledd (m,np,tautob,ssatob,asytob,dsm,rst,tst,dum)
c        

        do k=1,np
         do i=1,m
            rr(i,k,1)=rrt(i,k)
            tt(i,k,1)=ttt(i,k)
            td(i,k,1)=tdt(i,k)
            rs(i,k,1)=rst(i,k)
            ts(i,k,1)=tst(i,k)
         enddo
        enddo

c-----compute reflectance and transmittance of the cloudy portion of a layer

        do k=1,np
         do i=1,m

c-----for direct incident radiation. Eqs.(6.2)-(6.4)

           tautob(i,k)=tausto(i,k)+tauclb(i,k)
           ssatob(i,k)=(ssatau(i,k)+ssacl(i,k)*tauclb(i,k))
     *                /tautob(i,k)+1.0e-8
           ssatob(i,k)=min(ssatob(i,k),0.999999)
           asytob(i,k)=(asysto(i,k)+asycl(i,k)*ssacl(i,k)*tauclb(i,k))
     *                /(ssatob(i,k)*tautob(i,k))

c-----for diffuse incident radiation

           tautof(i,k)=tausto(i,k)+tauclf(i,k)
           ssatof(i,k)=(ssatau(i,k)+ssacl(i,k)*tauclf(i,k))
     *                /tautof(i,k)+1.0e-8
           ssatof(i,k)=min(ssatof(i,k),0.999999)
           asytof(i,k)=(asysto(i,k)+asycl(i,k)*ssacl(i,k)*tauclf(i,k))
     *                /(ssatof(i,k)*tautof(i,k))

         enddo
        enddo
	
c        
c-----for direct incident radiation

          call deledd (m,np,tautob,ssatob,asytob,cosz,rrt,ttt,tdt)

c-----diffuse incident radiation is approximated by beam radiation with
c     an incident angle of 53 degrees, Eqs.(6.5) and (6.6)
ctar	 
          call deledd (m,np,tautof,ssatof,asytof,dsm,rst,tst,dum)
ctar	  	  
        do k=1,np
         do i=1,m

            rr(i,k,2)=rrt(i,k)
            tt(i,k,2)=ttt(i,k)
            td(i,k,2)=tdt(i,k)
            rs(i,k,2)=rst(i,k)
            ts(i,k,2)=tst(i,k)

         enddo
        enddo

c-----flux calculations

c-----initialize clear-sky flux (fclr), all-sky flux (fall), 
c     and surface downward fluxes (fsdir and fsdif)

        do k=1,np+1
         do i=1,m
           fclr(i,k)=0.0
           fall(i,k)=0.0
           fclr_d(i,k)=0.0  ! NEW           
           fclr_u(i,k)=0.0  ! NEW           
           fall_d(i,k)=0.0  ! NEW
           fall_u(i,k)=0.0  ! NEW
	   dum1(i,k)=0.0                  
         
         enddo
        enddo
ctar	
ctar     
        do i=1,m
           fsdir(i)=0.0
           fsdif(i)=0.0
	   dum2(i)=0.0
        enddo

        if (overcast) then

              ih1=1
              ih2=1
              im1=1
              im2=1
              is1=1
              is2=1

c-----for clear-sky fluxes only
	 
         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,fclr,dum1,dum2,dum2,
     *                fclr_d,fclr_u,dum1,dum1)   ! NEW     

           do k=1,np+1
            do i=1,m
              fall(i,k)=0.0
           fall_d(i,k)=0.0  ! NEW
           fall_u(i,k)=0.0  ! NEW 
	   dum1(i,k)=0.0              
C              
            enddo
           enddo

           do i=1,m
              fsdir(i)=0.0
              fsdif(i)=0.0
           enddo
              ih1=2
              ih2=2
              im1=2
              im2=2
              is1=2
              is2=2
	      
c    
c-----for cloudy-sky fluxes only

         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,dum1,fall,fsdir,fsdif,
     *                 dum1,dum1,fall_d,fall_u)  ! NEW   

        else

              ih1=1
              ih2=2
              im1=1
              im2=2
              is1=1
              is2=2

c-----for clear- and all-sky fluxes
c     the all-sky flux, fall is the summation inside the brackets
c     of Eq. (7.11)
c	 
         call cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *                cc,rr,tt,td,rs,ts,fclr,fall,fsdir,fsdif,
     *               fclr_d,fclr_u,fall_d,fall_u)   ! NEW     

        endif

c-----flux integration following Eq. (6.1)

       do k=1,np+1
        do i=1,m
          flx_d(i,k)=flx_d(i,k)+fall_d(i,k)*hk(ib,ik) !NEW         
          flx_u(i,k)=flx_u(i,k)+fall_u(i,k)*hk(ib,ik) !NEW           
          flx(i,k) = flx(i,k)+fall(i,k)*hk(ib,ik)
          
        enddo

        do i=1,m
          flc(i,k) = flc(i,k)+fclr(i,k)*hk(ib,ik)
          flc_d(i,k)=flc_d(i,k)+fclr_d(i,k)*hk(ib,ik) !NEW           
          flc_u(i,k)=flc_u(i,k)+fclr_u(i,k)*hk(ib,ik) !NEW        
        enddo
       enddo

c-----compute downward surface fluxes in the ir region

       do i=1,m
          fdirir(i) = fdirir(i)+fsdir(i)*hk(ib,ik)
          fdifir(i) = fdifir(i)+fsdif(i)*hk(ib,ik)
       enddo

  200 continue
  100 continue
c  
c
 210   format (3E12.4)  
c 
      return
      end
c      
c*******************************************************************

      subroutine cldflx (m,np,ict,icb,ih1,ih2,im1,im2,is1,is2,
     *           cc,rr,tt,td,rs,ts,fclr,fall,fsdir,fsdif,
     *   fclr_d,fclr_u,fall_d,fall_u)      ! NEW

c*******************************************************************
c   Chou and Suarez 1999
c  compute upward and downward fluxes using a two-stream adding method
c  following equations (6.9)-(6.16).
c
c  clouds are grouped into high, middle, and low clouds which are assumed
c  randomly overlapped. It involves a maximum of 8 sets of calculations.
c  In each set of calculations, each atmospheric layer is homogeneous,
c  either totally filled with clouds or without clouds.

c  input parameters:
c
c   m:   number of soundings
c   np:  number of atmospheric layers
c   ict: the level separating high and middle clouds
c   icb: the level separating middle and low clouds
c   ih1,ih2,im1,im2,is1,is2: indices for three group of clouds
c   cc:  effective cloud covers for high, middle and low clouds
c   rr:  reflection of a layer illuminated by beam radiation
c   tt:  total diffuse transmission of a layer illuminated by beam radiation
c   td:  direct beam transmission
c   rs:  reflection of a layer illuminated by diffuse radiation
c   ts:  transmission of a layer illuminated by diffuse radiation
c
c  output parameters:
c
c     fclr:  clear-sky flux (downward minus upward)
c     fall:  all-sky flux (downward minus upward)
c     fsdir: surface direct downward flux
c     fsdif: surface diffuse downward flux
c
c*********************************************************************c

      implicit none

c-----input parameters

      integer m,np,ict,icb,ih1,ih2,im1,im2,is1,is2

      real rr(m,np+1,2),tt(m,np+1,2),td(m,np+1,2)
      real rs(m,np+1,2),ts(m,np+1,2)
      real cc(m,3)

c-----temporary array

      integer i,k,ih,im,is
      real rra(m,np+1,2,2),tta(m,np+1,2,2),tda(m,np+1,2,2)
      real rsa(m,np+1,2,2),rxa(m,np+1,2,2)
      real ch(m),cm(m),ct(m),flxdn(m,np+1)
      real fdndir(m),fdndif(m),fupdif
      real denm,xx,yy
      REAL fdn(m,np+1), fup(m,np+1)   !NEW      

c-----output parameters

      real fclr(m,np+1),fall(m,np+1)
      REAL fclr_u(m,np+1),fclr_d(m,np+1) !NEW
      REAL fall_u(m,np+1), fall_d (m,np+1)  !NEW    
      real fsdir(m),fsdif(m)

c-----compute transmittances and reflectances for a composite of
c     layers. layers are added one at a time, going down from the top.
c     tda is the composite transmittance illuminated by beam radiation
c     tta is the composite total transmittance illuminated by
c         beam radiation
c     rsa is the composite reflectance illuminated from below
c         by diffuse radiation
c     tta and rsa are computed from Eqs. (6.10) and (6.12)

c-----for high clouds
c     ih=1 for clear-sky condition, ih=2 for cloudy-sky condition

      do ih=ih1,ih2

       do i=1,m
          tda(i,1,ih,1)=td(i,1,ih)
          tta(i,1,ih,1)=tt(i,1,ih)
          rsa(i,1,ih,1)=rs(i,1,ih)
          tda(i,1,ih,2)=td(i,1,ih)
          tta(i,1,ih,2)=tt(i,1,ih)
          rsa(i,1,ih,2)=rs(i,1,ih)
       enddo

       do k=2,ict-1
        do i=1,m
          denm = ts(i,k,ih)/( 1.-rsa(i,k-1,ih,1)*rs(i,k,ih))
          tda(i,k,ih,1)= tda(i,k-1,ih,1)*td(i,k,ih)
          tta(i,k,ih,1)= tda(i,k-1,ih,1)*tt(i,k,ih)
     *          +(tda(i,k-1,ih,1)*rsa(i,k-1,ih,1)*rr(i,k,ih)
     *          +tta(i,k-1,ih,1)-tda(i,k-1,ih,1))*denm
          rsa(i,k,ih,1)= rs(i,k,ih)+ts(i,k,ih)
     *                  *rsa(i,k-1,ih,1)*denm
          tda(i,k,ih,2)= tda(i,k,ih,1)
          tta(i,k,ih,2)= tta(i,k,ih,1)
          rsa(i,k,ih,2)= rsa(i,k,ih,1)
        enddo

       enddo

c-----for middle clouds
c     im=1 for clear-sky condition, im=2 for cloudy-sky condition
      do im=im1,im2

       do k=ict,icb-1
        do i=1,m
          denm = ts(i,k,im)/( 1.-rsa(i,k-1,ih,im)*rs(i,k,im))
          tda(i,k,ih,im)= tda(i,k-1,ih,im)*td(i,k,im)
          tta(i,k,ih,im)= tda(i,k-1,ih,im)*tt(i,k,im)
     *         +(tda(i,k-1,ih,im)*rsa(i,k-1,ih,im)*rr(i,k,im)
     *         +tta(i,k-1,ih,im)-tda(i,k-1,ih,im))*denm
          rsa(i,k,ih,im)= rs(i,k,im)+ts(i,k,im)
     *                  *rsa(i,k-1,ih,im)*denm
        enddo
       enddo

      enddo                 ! end im loop
      enddo                 ! end ih loop



c-----layers are added one at a time, going up from the surface.
c     rra is the composite reflectance illuminated by beam radiation
c     rxa is the composite reflectance illuminated from above
c         by diffuse radiation
c     rra and rxa are computed from Eqs. (6.9) and (6.11)
 
c-----for the low clouds
c     is=1 for clear-sky condition, is=2 for cloudy-sky condition

      do is=is1,is2

       do i=1,m
         rra(i,np+1,1,is)=rr(i,np+1,is)
         rxa(i,np+1,1,is)=rs(i,np+1,is)
         rra(i,np+1,2,is)=rr(i,np+1,is)
         rxa(i,np+1,2,is)=rs(i,np+1,is)
       enddo

       do k=np,icb,-1
        do i=1,m
          denm=ts(i,k,is)/( 1.-rs(i,k,is)*rxa(i,k+1,1,is) )
          rra(i,k,1,is)=rr(i,k,is)+(td(i,k,is)*rra(i,k+1,1,is)
     *        +(tt(i,k,is)-td(i,k,is))*rxa(i,k+1,1,is))*denm
          rxa(i,k,1,is)= rs(i,k,is)+ts(i,k,is)
     *        *rxa(i,k+1,1,is)*denm
          rra(i,k,2,is)=rra(i,k,1,is)
          rxa(i,k,2,is)=rxa(i,k,1,is)
        enddo
       enddo

c-----for middle clouds

      do im=im1,im2

       do k=icb-1,ict,-1
        do i=1,m
          denm=ts(i,k,im)/( 1.-rs(i,k,im)*rxa(i,k+1,im,is) )
          rra(i,k,im,is)= rr(i,k,im)+(td(i,k,im)*rra(i,k+1,im,is)
     *        +(tt(i,k,im)-td(i,k,im))*rxa(i,k+1,im,is))*denm
          rxa(i,k,im,is)= rs(i,k,im)+ts(i,k,im)
     *        *rxa(i,k+1,im,is)*denm
        enddo
       enddo

      enddo                 ! end im loop
      enddo                 ! end is loop

c-----integration over eight sky situations.
c     ih, im, is denotes high, middle and low cloud groups.

      do ih=ih1,ih2

c-----clear portion 

         if(ih.eq.1) then
           do i=1,m
             ch(i)=1.0-cc(i,1)
           enddo

          else

c-----cloudy portion

           do i=1,m
             ch(i)=cc(i,1)
           enddo

          endif

      do im=im1,im2

c-----clear portion

         if(im.eq.1) then

           do i=1,m
              cm(i)=ch(i)*(1.0-cc(i,2))
           enddo

         else

c-----cloudy portion

           do i=1,m
              cm(i)=ch(i)*cc(i,2) 
           enddo

         endif

      do is=is1,is2

c-----clear portion

         if(is.eq.1) then

           do i=1,m
             ct(i)=cm(i)*(1.0-cc(i,3)) 
           enddo

         else

c-----cloudy portion

           do i=1,m
             ct(i)=cm(i)*cc(i,3)
           enddo

         endif

c-----add one layer at a time, going down.

       do k=icb,np
        do i=1,m
          denm = ts(i,k,is)/( 1.-rsa(i,k-1,ih,im)*rs(i,k,is) )
          tda(i,k,ih,im)= tda(i,k-1,ih,im)*td(i,k,is)
          tta(i,k,ih,im)=  tda(i,k-1,ih,im)*tt(i,k,is)
     *         +(tda(i,k-1,ih,im)*rr(i,k,is)
     *         *rsa(i,k-1,ih,im)+tta(i,k-1,ih,im)-tda(i,k-1,ih,im))*denm
          rsa(i,k,ih,im)= rs(i,k,is)+ts(i,k,is)
     *         *rsa(i,k-1,ih,im)*denm
        enddo
       enddo

c-----add one layer at a time, going up.

       do k=ict-1,1,-1
        do i=1,m
          denm =ts(i,k,ih)/(1.-rs(i,k,ih)*rxa(i,k+1,im,is))
          rra(i,k,im,is)= rr(i,k,ih)+(td(i,k,ih)*rra(i,k+1,im,is)
     *        +(tt(i,k,ih)-td(i,k,ih))*rxa(i,k+1,im,is))*denm
          rxa(i,k,im,is)= rs(i,k,ih)+ts(i,k,ih)
     *        *rxa(i,k+1,im,is)*denm
        enddo
       enddo

c-----compute fluxes following Eq. (6.15) for fupdif and
c     Eq. (6.16) for (fdndir+fdndif)
 
c     fdndir is the direct  downward flux
c     fdndif is the diffuse downward flux
c     fupdif is the diffuse upward flux

      do k=2,np+1
       do i=1,m
         denm= 1./(1.-rsa(i,k-1,ih,im)*rxa(i,k,im,is))
         fdndir(i)= tda(i,k-1,ih,im)
         xx= tda(i,k-1,ih,im)*rra(i,k,im,is)
         yy= tta(i,k-1,ih,im)-tda(i,k-1,ih,im)
         fdndif(i)= (xx*rsa(i,k-1,ih,im)+yy)*denm
C
C--CALCULATION OF DOWNWARD (fdn(i,k)) and UPWARD (fupdif(i,k)) FLUXES
C  as well as net flux
C 
         fupdif= (xx+yy*rxa(i,k,im,is))*denm         
         flxdn(i,k)= fdndir(i)+fdndif(i)-fupdif  ! NET FLUX
C          flxdn(i,k)= fdndir(i)+fdndif(i)
          fup(i,k)= (xx+yy*rxa(i,k,im,is))*denm   !NEW         
          fdn(i,k)= fdndir(i)+fdndif(i)        !NEW 
       enddo
      enddo

       do i=1,m
          flxdn(i,1)=1.0-rra(i,1,im,is)
C           flxdn(i,1)=1.0
          fdn(i,1)=1.0 
          fup(i,1)=rra(i,1,im,is)                  
       enddo

c-----summation of fluxes over all sky situations;
c     the term in the brackets of Eq. (7.11)

       do k=1,np+1
        do i=1,m
           if(ih.eq.1 .and. im.eq.1 .and. is.eq.1) then
             fclr(i,k)=flxdn(i,k)
             fclr_d(i,k)=fdn(i,k)      ! NEW
             fclr_u(i,k)=fup(i,k)   ! NEW
           endif
             fall(i,k)=fall(i,k)+flxdn(i,k)*ct(i)
             fall_d(i,k)=fall_d(i,k)+fdn(i,k)*ct(i)      ! NEW             
             fall_u(i,k)=fall_u(i,k)+fup(i,k)*ct(i)   ! NEW            
        enddo
       enddo

        do i=1,m
            fsdir(i)=fsdir(i)+fdndir(i)*ct(i)
            fsdif(i)=fsdif(i)+fdndif(i)*ct(i)
        enddo

       enddo                 ! end is loop
       enddo                 ! end im loop
       enddo                 ! end ih loop

      return
      end
c
c********************************************************************

      subroutine cldscale (m,np,cosz,fcld,taucld,ict,icb,
     *                     cc,tauclb,tauclf)

c********************************************************************
c   Chou and Suarez 1999
c   This subroutine computes the high, middle, and low cloud
c    amounts and scales the cloud optical thickness (section 7)
c
c   To simplify calculations in a cloudy atmosphere, clouds are
c    grouped into high, middle and low clouds separated by the levels
c    ict and icb (level 1 is the top of the model atmosphere).
c
c   Within each of the three groups, clouds are assumed maximally
c    overlapped, and the cloud cover (cc) of a group is the maximum
c    cloud cover of all the layers in the group.  The optical thickness
c    (taucld) of a given layer is then scaled to new values (tauclb and
c    tauclf) so that the layer reflectance corresponding to the cloud
c    cover cc is the same as the original reflectance with optical
c    thickness taucld and cloud cover fcld.
c
c---input parameters
c
c    number of atmospheric soundings (m)
c    number of atmospheric layers (np)
c    cosine of the solar zenith angle (cosz)
c    fractional cloud cover (fcld)
c    cloud optical thickness (taucld)
c    index separating high and middle clouds (ict)
c    index separating middle and low clouds (icb)
c
c---output parameters
c
c    fractional cover of high, middle, and low cloud groups (cc)
c    scaled cloud optical thickness for direct  radiation (tauclb)
c    scaled cloud optical thickness for diffuse radiation (tauclf)
c
c********************************************************************

      implicit none

c-----input parameters

      integer m,np,ict,icb
      real cosz(m),fcld(m,np),taucld(m,np,3)

c-----output parameters

      real cc(m,3),tauclb(m,np),tauclf(m,np)

c-----temporary variables

      integer i,j,k,im,it,ia,kk
      real  fm,ft,fa,xai,taux

c-----pre-computed table
c     size of cosz-interval:         dm
c     size of taucld-interval:       dt
c     size of cloud amount-interval: da

      integer   nm,nt,na
      parameter (nm=11,nt=9,na=11) 
      real  dm,dt,da,t1,caib(nm,nt,na),caif(nt,na)
      parameter (dm=0.1,dt=0.30103,da=0.1,t1=-0.9031)

c-----include the pre-computed table of mcai for scaling the cloud optical
c     thickness under the assumption that clouds are maximally overlapped
c
c     caib is for scaling the cloud optical thickness for direct radiation
c     caif is for scaling the cloud optical thickness for diffuse radiation

      include "mcai.data"

c-----clouds within each of the high, middle, and low clouds are assumed
c     to be maximally overlapped, and the cloud cover (cc) for a group
c     (high, middle, or low) is the maximum cloud cover of all the layers
c     within a group

      do i=1,m
         cc(i,1)=0.0
         cc(i,2)=0.0
         cc(i,3)=0.0
      enddo

      do k=1,ict-1
       do i=1,m
          cc(i,1)=max(cc(i,1),fcld(i,k))
       enddo
      enddo

      do k=ict,icb-1
       do i=1,m
          cc(i,2)=max(cc(i,2),fcld(i,k))
       enddo
      enddo

      do k=icb,np
       do i=1,m
          cc(i,3)=max(cc(i,3),fcld(i,k))
       enddo
      enddo

c-----scale the cloud optical thickness.
c     taucld(i,k,1) is the optical thickness for ice particles
c     taucld(i,k,2) is the optical thickness for liquid particles
c     taucld(i,k,3) is the optical thickness for rain drops
      
      do k=1,np

         if(k.lt.ict) then
            kk=1
         elseif(k.ge.ict .and. k.lt.icb) then
            kk=2
         else
            kk=3
         endif

       do i=1,m

         tauclb(i,k) = 0.0
         tauclf(i,k) = 0.0
         taux=taucld(i,k,1)+taucld(i,k,2)+taucld(i,k,3)

         if (taux.gt.0.02 .and. fcld(i,k).gt.0.01) then

c-----normalize cloud cover following Eq. (7.8)

           fa=fcld(i,k)/cc(i,kk)

c-----table look-up

           taux=min(taux,32.)

           fm=cosz(i)/dm
           ft=(log10(taux)-t1)/dt
           fa=fa/da
 
           im=int(fm+1.5)
           it=int(ft+1.5)
           ia=int(fa+1.5)
  
           im=max(im,2)
           it=max(it,2)
           ia=max(ia,2)
     
           im=min(im,nm-1)
           it=min(it,nt-1)
           ia=min(ia,na-1)

           fm=fm-float(im-1)
           ft=ft-float(it-1)
           fa=fa-float(ia-1)

c-----scale cloud optical thickness for beam radiation following Eq. (7.3)
c     the scaling factor, xai, is a function of the solar zenith
c     angle, optical thickness, and cloud cover.
 
           xai=    (-caib(im-1,it,ia)*(1.-fm)+
     *      caib(im+1,it,ia)*(1.+fm))*fm*.5+caib(im,it,ia)*(1.-fm*fm)
         
           xai=xai+(-caib(im,it-1,ia)*(1.-ft)+
     *      caib(im,it+1,ia)*(1.+ft))*ft*.5+caib(im,it,ia)*(1.-ft*ft)

           xai=xai+(-caib(im,it,ia-1)*(1.-fa)+
     *     caib(im,it,ia+1)*(1.+fa))*fa*.5+caib(im,it,ia)*(1.-fa*fa)

           xai= xai-2.*caib(im,it,ia)
           xai=max(xai,0.0)
     
           tauclb(i,k) = taux*xai

c-----scale cloud optical thickness for diffuse radiation following Eq. (7.4)
c     the scaling factor, xai, is a function of the cloud optical
c     thickness and cover but not the solar zenith angle.

           xai=    (-caif(it-1,ia)*(1.-ft)+
     *      caif(it+1,ia)*(1.+ft))*ft*.5+caif(it,ia)*(1.-ft*ft)

           xai=xai+(-caif(it,ia-1)*(1.-fa)+
     *      caif(it,ia+1)*(1.+fa))*fa*.5+caif(it,ia)*(1.-fa*fa)

           xai= xai-caif(it,ia)
           xai=max(xai,0.0)
     
           tauclf(i,k) = taux*xai

         endif

       enddo
      enddo

      return
      end
c
c*********************************************************************

      subroutine deledd(m,np,tau,ssc,g0,cza,rr,tt,td)

c*********************************************************************
c     Chou and Suarez, 1999
c-----uses the delta-eddington approximation to compute the
c     bulk scattering properties of a single layer
c     coded following King and Harshvardhan (JAS, 1986)
c
c  inputs:
c       m:  number of soundings
c      np:  number of atmospheric layers
c     tau:  optical thickness
c     ssc:  single scattering albedo
c     g0:   asymmetry factor
c     cza:  cosine of the zenith angle
c
c  outputs:
c
c     rr:  reflection of the direct beam
c     tt:  total diffuse transmission of the direct beam
c     td:  direct transmission of the direct beam
c
c*********************************************************************
C
C
      implicit none

      real zero,one,two,three,four,fourth,seven,thresh
      parameter (one =1., three=3.)
      parameter (two =2., seven=7.)
      parameter (four=4., fourth=.25)
      parameter (zero=0., thresh=1.e-8)

c-----input parameters
      integer m,np
      real tau(m,np),ssc(m,np),g0(m,np),cza(m)

c-----output parameters
      real rr(m,np+1),tt(m,np+1),td(m,np+1)

c-----temporary parameters

      integer i,k
      real zth,ff,xx,taup,sscp,gp,gm1,gm2,gm3,akk,alf1,alf2,
     *     all,bll,st7,st8,cll,dll,fll,ell,st1,st2,st3,st4
 
c---------------------------------------------------------------------
C
C
      do k=1,np
       do i=1,m
C
          zth = cza(i)
 
c  delta-eddington scaling of single scattering albedo,
c  optical thickness, and asymmetry factor,
c  K & H eqs(27-29)

           ff  = g0(i,k)*g0(i,k)
           xx  = one-ff *ssc(i,k)
           taup= tau(i,k)*xx
           sscp= ssc(i,k)*(one-ff)/xx
           gp  = g0(i,k) /(one+g0(i,k))           
C            
c  gamma1, gamma2, and gamma3. see table 2 and eq(26) K & H
c  ssc and gp are the d-s single scattering
c  albedo and asymmetry factor.

           xx  =  three*gp 
           gm1 =  (seven - sscp*(four+xx))*fourth
           gm2 = -(one   - sscp*(four-xx))*fourth

c  akk is k as defined in eq(25) of K & H
 
           akk = sqrt((gm1+gm2)*(gm1-gm2))
 
           xx  = akk * zth
           st7 = one - xx
           st8 = one + xx
           st3 = st7 * st8

           if (abs(st3) .lt. thresh) then
               zth = zth + 0.001
               xx  = akk * zth
               st7 = one - xx
               st8 = one + xx
               st3 = st7 * st8
           endif
C
C 
c  extinction of the direct beam transmission
 
           td(i,k)  = exp(-taup/zth)

c  alf1 and alf2 are alpha1 and alpha2 from eqs (23) & (24) of K & H
 
           gm3  = (two - zth*three*gp)*fourth
           xx   = gm1 - gm2
           alf1 = gm1 - gm3 * xx
           alf2 = gm2 + gm3 * xx
 
c  all is last term in eq(21) of K & H
c  bll is last term in eq(22) of K & H
 
           xx  = akk * two
           all = (gm3 - alf2 * zth    )*xx*td(i,k)
           bll = (one - gm3 + alf1*zth)*xx
 
           xx  = akk * gm3
           cll = (alf2 + xx) * st7
           dll = (alf2 - xx) * st8
 
           xx  = akk * (one-gm3)
           fll = (alf1 + xx) * st8
           ell = (alf1 - xx) * st7
  
           st2 = exp(-akk*taup)
           st4 = st2 * st2
 
           st1 =  sscp / ((akk+gm1 + (akk-gm1)*st4) * st3)
 
c  rr is r-hat of eq(21) of K & H
c  tt is diffuse part of t-hat of eq(22) of K & H
 
           rr(i,k) =   ( cll-dll*st4         -all*st2)*st1
           tt(i,k) = - ((fll-ell*st4)*td(i,k)-bll*st2)*st1
 
           rr(i,k) = max(rr(i,k),zero)
           tt(i,k) = max(tt(i,k),zero)

           tt(i,k) = tt(i,k)+td(i,k)
C
C
        enddo
       enddo
C
C
      return
      end
      
      
      

